use std::future::Future;

use anyhow::Result;
use tokio::io::AsyncWrite;

use crate::RegisteredUser;
use lavina_core::player::PlayerConnection;
use lavina_core::prelude::Str;

pub struct IrcConnection<'a, T: AsyncWrite + Unpin> {
    pub server_name: Str,
    pub writer: &'a mut T,
    pub player_connection: &'a mut PlayerConnection,
    pub user: &'a RegisteredUser,
}

/// Represents a client-to-server IRC message that can be handled by the server.
pub trait IrcCommand {
    fn handle_with(&self, conn: &mut IrcConnection<impl AsyncWrite + Unpin>) -> impl Future<Output = Result<()>>;
}
